// Code generated by SQLBoiler 4.14.2 (https://github.com/volatiletech/sqlboiler). DO NOT EDIT.
// This file is meant to be re-generated in place and/or deleted at any time.

package models

import (
	"context"
	"database/sql"
	"fmt"
	"reflect"
	"strconv"
	"strings"
	"sync"
	"time"

	"github.com/friendsofgo/errors"
	"github.com/volatiletech/null/v8"
	"github.com/volatiletech/sqlboiler/v4/boil"
	"github.com/volatiletech/sqlboiler/v4/queries"
	"github.com/volatiletech/sqlboiler/v4/queries/qm"
	"github.com/volatiletech/sqlboiler/v4/queries/qmhelper"
	"github.com/volatiletech/strmangle"
)

// RedeemOrderGoal is an object representing the database table.
type RedeemOrderGoal struct {
	ID         int64      `boil:"id" json:"id" toml:"id" yaml:"id"`
	Amount     null.Int   `boil:"amount" json:"amount,omitempty" toml:"amount" yaml:"amount,omitempty"`
	DateRedeem null.Time  `boil:"date_redeem" json:"date_redeem,omitempty" toml:"date_redeem" yaml:"date_redeem,omitempty"`
	OrderID    null.Int64 `boil:"order_id" json:"order_id,omitempty" toml:"order_id" yaml:"order_id,omitempty"`
	CreatedAt  time.Time  `boil:"created_at" json:"created_at" toml:"created_at" yaml:"created_at"`
	UpdatedAt  time.Time  `boil:"updated_at" json:"updated_at" toml:"updated_at" yaml:"updated_at"`

	R *redeemOrderGoalR `boil:"-" json:"-" toml:"-" yaml:"-"`
	L redeemOrderGoalL  `boil:"-" json:"-" toml:"-" yaml:"-"`
}

var RedeemOrderGoalColumns = struct {
	ID         string
	Amount     string
	DateRedeem string
	OrderID    string
	CreatedAt  string
	UpdatedAt  string
}{
	ID:         "id",
	Amount:     "amount",
	DateRedeem: "date_redeem",
	OrderID:    "order_id",
	CreatedAt:  "created_at",
	UpdatedAt:  "updated_at",
}

var RedeemOrderGoalTableColumns = struct {
	ID         string
	Amount     string
	DateRedeem string
	OrderID    string
	CreatedAt  string
	UpdatedAt  string
}{
	ID:         "redeem_order_goal.id",
	Amount:     "redeem_order_goal.amount",
	DateRedeem: "redeem_order_goal.date_redeem",
	OrderID:    "redeem_order_goal.order_id",
	CreatedAt:  "redeem_order_goal.created_at",
	UpdatedAt:  "redeem_order_goal.updated_at",
}

// Generated where

var RedeemOrderGoalWhere = struct {
	ID         whereHelperint64
	Amount     whereHelpernull_Int
	DateRedeem whereHelpernull_Time
	OrderID    whereHelpernull_Int64
	CreatedAt  whereHelpertime_Time
	UpdatedAt  whereHelpertime_Time
}{
	ID:         whereHelperint64{field: "\"redeem_order_goal\".\"id\""},
	Amount:     whereHelpernull_Int{field: "\"redeem_order_goal\".\"amount\""},
	DateRedeem: whereHelpernull_Time{field: "\"redeem_order_goal\".\"date_redeem\""},
	OrderID:    whereHelpernull_Int64{field: "\"redeem_order_goal\".\"order_id\""},
	CreatedAt:  whereHelpertime_Time{field: "\"redeem_order_goal\".\"created_at\""},
	UpdatedAt:  whereHelpertime_Time{field: "\"redeem_order_goal\".\"updated_at\""},
}

// RedeemOrderGoalRels is where relationship names are stored.
var RedeemOrderGoalRels = struct {
	Order string
}{
	Order: "Order",
}

// redeemOrderGoalR is where relationships are stored.
type redeemOrderGoalR struct {
	Order *OrderGoal `boil:"Order" json:"Order" toml:"Order" yaml:"Order"`
}

// NewStruct creates a new relationship struct
func (*redeemOrderGoalR) NewStruct() *redeemOrderGoalR {
	return &redeemOrderGoalR{}
}

func (r *redeemOrderGoalR) GetOrder() *OrderGoal {
	if r == nil {
		return nil
	}
	return r.Order
}

// redeemOrderGoalL is where Load methods for each relationship are stored.
type redeemOrderGoalL struct{}

var (
	redeemOrderGoalAllColumns            = []string{"id", "amount", "date_redeem", "order_id", "created_at", "updated_at"}
	redeemOrderGoalColumnsWithoutDefault = []string{}
	redeemOrderGoalColumnsWithDefault    = []string{"id", "amount", "date_redeem", "order_id", "created_at", "updated_at"}
	redeemOrderGoalPrimaryKeyColumns     = []string{"id"}
	redeemOrderGoalGeneratedColumns      = []string{}
)

type (
	// RedeemOrderGoalSlice is an alias for a slice of pointers to RedeemOrderGoal.
	// This should almost always be used instead of []RedeemOrderGoal.
	RedeemOrderGoalSlice []*RedeemOrderGoal
	// RedeemOrderGoalHook is the signature for custom RedeemOrderGoal hook methods
	RedeemOrderGoalHook func(context.Context, boil.ContextExecutor, *RedeemOrderGoal) error

	redeemOrderGoalQuery struct {
		*queries.Query
	}
)

// Cache for insert, update and upsert
var (
	redeemOrderGoalType                 = reflect.TypeOf(&RedeemOrderGoal{})
	redeemOrderGoalMapping              = queries.MakeStructMapping(redeemOrderGoalType)
	redeemOrderGoalPrimaryKeyMapping, _ = queries.BindMapping(redeemOrderGoalType, redeemOrderGoalMapping, redeemOrderGoalPrimaryKeyColumns)
	redeemOrderGoalInsertCacheMut       sync.RWMutex
	redeemOrderGoalInsertCache          = make(map[string]insertCache)
	redeemOrderGoalUpdateCacheMut       sync.RWMutex
	redeemOrderGoalUpdateCache          = make(map[string]updateCache)
	redeemOrderGoalUpsertCacheMut       sync.RWMutex
	redeemOrderGoalUpsertCache          = make(map[string]insertCache)
)

var (
	// Force time package dependency for automated UpdatedAt/CreatedAt.
	_ = time.Second
	// Force qmhelper dependency for where clause generation (which doesn't
	// always happen)
	_ = qmhelper.Where
)

var redeemOrderGoalAfterSelectHooks []RedeemOrderGoalHook

var redeemOrderGoalBeforeInsertHooks []RedeemOrderGoalHook
var redeemOrderGoalAfterInsertHooks []RedeemOrderGoalHook

var redeemOrderGoalBeforeUpdateHooks []RedeemOrderGoalHook
var redeemOrderGoalAfterUpdateHooks []RedeemOrderGoalHook

var redeemOrderGoalBeforeDeleteHooks []RedeemOrderGoalHook
var redeemOrderGoalAfterDeleteHooks []RedeemOrderGoalHook

var redeemOrderGoalBeforeUpsertHooks []RedeemOrderGoalHook
var redeemOrderGoalAfterUpsertHooks []RedeemOrderGoalHook

// doAfterSelectHooks executes all "after Select" hooks.
func (o *RedeemOrderGoal) doAfterSelectHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range redeemOrderGoalAfterSelectHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doBeforeInsertHooks executes all "before insert" hooks.
func (o *RedeemOrderGoal) doBeforeInsertHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range redeemOrderGoalBeforeInsertHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doAfterInsertHooks executes all "after Insert" hooks.
func (o *RedeemOrderGoal) doAfterInsertHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range redeemOrderGoalAfterInsertHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doBeforeUpdateHooks executes all "before Update" hooks.
func (o *RedeemOrderGoal) doBeforeUpdateHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range redeemOrderGoalBeforeUpdateHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doAfterUpdateHooks executes all "after Update" hooks.
func (o *RedeemOrderGoal) doAfterUpdateHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range redeemOrderGoalAfterUpdateHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doBeforeDeleteHooks executes all "before Delete" hooks.
func (o *RedeemOrderGoal) doBeforeDeleteHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range redeemOrderGoalBeforeDeleteHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doAfterDeleteHooks executes all "after Delete" hooks.
func (o *RedeemOrderGoal) doAfterDeleteHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range redeemOrderGoalAfterDeleteHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doBeforeUpsertHooks executes all "before Upsert" hooks.
func (o *RedeemOrderGoal) doBeforeUpsertHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range redeemOrderGoalBeforeUpsertHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doAfterUpsertHooks executes all "after Upsert" hooks.
func (o *RedeemOrderGoal) doAfterUpsertHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range redeemOrderGoalAfterUpsertHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// AddRedeemOrderGoalHook registers your hook function for all future operations.
func AddRedeemOrderGoalHook(hookPoint boil.HookPoint, redeemOrderGoalHook RedeemOrderGoalHook) {
	switch hookPoint {
	case boil.AfterSelectHook:
		redeemOrderGoalAfterSelectHooks = append(redeemOrderGoalAfterSelectHooks, redeemOrderGoalHook)
	case boil.BeforeInsertHook:
		redeemOrderGoalBeforeInsertHooks = append(redeemOrderGoalBeforeInsertHooks, redeemOrderGoalHook)
	case boil.AfterInsertHook:
		redeemOrderGoalAfterInsertHooks = append(redeemOrderGoalAfterInsertHooks, redeemOrderGoalHook)
	case boil.BeforeUpdateHook:
		redeemOrderGoalBeforeUpdateHooks = append(redeemOrderGoalBeforeUpdateHooks, redeemOrderGoalHook)
	case boil.AfterUpdateHook:
		redeemOrderGoalAfterUpdateHooks = append(redeemOrderGoalAfterUpdateHooks, redeemOrderGoalHook)
	case boil.BeforeDeleteHook:
		redeemOrderGoalBeforeDeleteHooks = append(redeemOrderGoalBeforeDeleteHooks, redeemOrderGoalHook)
	case boil.AfterDeleteHook:
		redeemOrderGoalAfterDeleteHooks = append(redeemOrderGoalAfterDeleteHooks, redeemOrderGoalHook)
	case boil.BeforeUpsertHook:
		redeemOrderGoalBeforeUpsertHooks = append(redeemOrderGoalBeforeUpsertHooks, redeemOrderGoalHook)
	case boil.AfterUpsertHook:
		redeemOrderGoalAfterUpsertHooks = append(redeemOrderGoalAfterUpsertHooks, redeemOrderGoalHook)
	}
}

// One returns a single redeemOrderGoal record from the query.
func (q redeemOrderGoalQuery) One(ctx context.Context, exec boil.ContextExecutor) (*RedeemOrderGoal, error) {
	o := &RedeemOrderGoal{}

	queries.SetLimit(q.Query, 1)

	err := q.Bind(ctx, exec, o)
	if err != nil {
		if errors.Is(err, sql.ErrNoRows) {
			return nil, sql.ErrNoRows
		}
		return nil, errors.Wrap(err, "models: failed to execute a one query for redeem_order_goal")
	}

	if err := o.doAfterSelectHooks(ctx, exec); err != nil {
		return o, err
	}

	return o, nil
}

// All returns all RedeemOrderGoal records from the query.
func (q redeemOrderGoalQuery) All(ctx context.Context, exec boil.ContextExecutor) (RedeemOrderGoalSlice, error) {
	var o []*RedeemOrderGoal

	err := q.Bind(ctx, exec, &o)
	if err != nil {
		return nil, errors.Wrap(err, "models: failed to assign all query results to RedeemOrderGoal slice")
	}

	if len(redeemOrderGoalAfterSelectHooks) != 0 {
		for _, obj := range o {
			if err := obj.doAfterSelectHooks(ctx, exec); err != nil {
				return o, err
			}
		}
	}

	return o, nil
}

// Count returns the count of all RedeemOrderGoal records in the query.
func (q redeemOrderGoalQuery) Count(ctx context.Context, exec boil.ContextExecutor) (int64, error) {
	var count int64

	queries.SetSelect(q.Query, nil)
	queries.SetCount(q.Query)

	err := q.Query.QueryRowContext(ctx, exec).Scan(&count)
	if err != nil {
		return 0, errors.Wrap(err, "models: failed to count redeem_order_goal rows")
	}

	return count, nil
}

// Exists checks if the row exists in the table.
func (q redeemOrderGoalQuery) Exists(ctx context.Context, exec boil.ContextExecutor) (bool, error) {
	var count int64

	queries.SetSelect(q.Query, nil)
	queries.SetCount(q.Query)
	queries.SetLimit(q.Query, 1)

	err := q.Query.QueryRowContext(ctx, exec).Scan(&count)
	if err != nil {
		return false, errors.Wrap(err, "models: failed to check if redeem_order_goal exists")
	}

	return count > 0, nil
}

// Order pointed to by the foreign key.
func (o *RedeemOrderGoal) Order(mods ...qm.QueryMod) orderGoalQuery {
	queryMods := []qm.QueryMod{
		qm.Where("\"id\" = ?", o.OrderID),
	}

	queryMods = append(queryMods, mods...)

	return OrderGoals(queryMods...)
}

// LoadOrder allows an eager lookup of values, cached into the
// loaded structs of the objects. This is for an N-1 relationship.
func (redeemOrderGoalL) LoadOrder(ctx context.Context, e boil.ContextExecutor, singular bool, maybeRedeemOrderGoal interface{}, mods queries.Applicator) error {
	var slice []*RedeemOrderGoal
	var object *RedeemOrderGoal

	if singular {
		var ok bool
		object, ok = maybeRedeemOrderGoal.(*RedeemOrderGoal)
		if !ok {
			object = new(RedeemOrderGoal)
			ok = queries.SetFromEmbeddedStruct(&object, &maybeRedeemOrderGoal)
			if !ok {
				return errors.New(fmt.Sprintf("failed to set %T from embedded struct %T", object, maybeRedeemOrderGoal))
			}
		}
	} else {
		s, ok := maybeRedeemOrderGoal.(*[]*RedeemOrderGoal)
		if ok {
			slice = *s
		} else {
			ok = queries.SetFromEmbeddedStruct(&slice, maybeRedeemOrderGoal)
			if !ok {
				return errors.New(fmt.Sprintf("failed to set %T from embedded struct %T", slice, maybeRedeemOrderGoal))
			}
		}
	}

	args := make([]interface{}, 0, 1)
	if singular {
		if object.R == nil {
			object.R = &redeemOrderGoalR{}
		}
		if !queries.IsNil(object.OrderID) {
			args = append(args, object.OrderID)
		}

	} else {
	Outer:
		for _, obj := range slice {
			if obj.R == nil {
				obj.R = &redeemOrderGoalR{}
			}

			for _, a := range args {
				if queries.Equal(a, obj.OrderID) {
					continue Outer
				}
			}

			if !queries.IsNil(obj.OrderID) {
				args = append(args, obj.OrderID)
			}

		}
	}

	if len(args) == 0 {
		return nil
	}

	query := NewQuery(
		qm.From(`order_goal`),
		qm.WhereIn(`order_goal.id in ?`, args...),
	)
	if mods != nil {
		mods.Apply(query)
	}

	results, err := query.QueryContext(ctx, e)
	if err != nil {
		return errors.Wrap(err, "failed to eager load OrderGoal")
	}

	var resultSlice []*OrderGoal
	if err = queries.Bind(results, &resultSlice); err != nil {
		return errors.Wrap(err, "failed to bind eager loaded slice OrderGoal")
	}

	if err = results.Close(); err != nil {
		return errors.Wrap(err, "failed to close results of eager load for order_goal")
	}
	if err = results.Err(); err != nil {
		return errors.Wrap(err, "error occurred during iteration of eager loaded relations for order_goal")
	}

	if len(orderGoalAfterSelectHooks) != 0 {
		for _, obj := range resultSlice {
			if err := obj.doAfterSelectHooks(ctx, e); err != nil {
				return err
			}
		}
	}

	if len(resultSlice) == 0 {
		return nil
	}

	if singular {
		foreign := resultSlice[0]
		object.R.Order = foreign
		if foreign.R == nil {
			foreign.R = &orderGoalR{}
		}
		foreign.R.OrderRedeemOrderGoals = append(foreign.R.OrderRedeemOrderGoals, object)
		return nil
	}

	for _, local := range slice {
		for _, foreign := range resultSlice {
			if queries.Equal(local.OrderID, foreign.ID) {
				local.R.Order = foreign
				if foreign.R == nil {
					foreign.R = &orderGoalR{}
				}
				foreign.R.OrderRedeemOrderGoals = append(foreign.R.OrderRedeemOrderGoals, local)
				break
			}
		}
	}

	return nil
}

// SetOrder of the redeemOrderGoal to the related item.
// Sets o.R.Order to related.
// Adds o to related.R.OrderRedeemOrderGoals.
func (o *RedeemOrderGoal) SetOrder(ctx context.Context, exec boil.ContextExecutor, insert bool, related *OrderGoal) error {
	var err error
	if insert {
		if err = related.Insert(ctx, exec, boil.Infer()); err != nil {
			return errors.Wrap(err, "failed to insert into foreign table")
		}
	}

	updateQuery := fmt.Sprintf(
		"UPDATE \"redeem_order_goal\" SET %s WHERE %s",
		strmangle.SetParamNames("\"", "\"", 1, []string{"order_id"}),
		strmangle.WhereClause("\"", "\"", 2, redeemOrderGoalPrimaryKeyColumns),
	)
	values := []interface{}{related.ID, o.ID}

	if boil.IsDebug(ctx) {
		writer := boil.DebugWriterFrom(ctx)
		fmt.Fprintln(writer, updateQuery)
		fmt.Fprintln(writer, values)
	}
	if _, err = exec.ExecContext(ctx, updateQuery, values...); err != nil {
		return errors.Wrap(err, "failed to update local table")
	}

	queries.Assign(&o.OrderID, related.ID)
	if o.R == nil {
		o.R = &redeemOrderGoalR{
			Order: related,
		}
	} else {
		o.R.Order = related
	}

	if related.R == nil {
		related.R = &orderGoalR{
			OrderRedeemOrderGoals: RedeemOrderGoalSlice{o},
		}
	} else {
		related.R.OrderRedeemOrderGoals = append(related.R.OrderRedeemOrderGoals, o)
	}

	return nil
}

// RemoveOrder relationship.
// Sets o.R.Order to nil.
// Removes o from all passed in related items' relationships struct.
func (o *RedeemOrderGoal) RemoveOrder(ctx context.Context, exec boil.ContextExecutor, related *OrderGoal) error {
	var err error

	queries.SetScanner(&o.OrderID, nil)
	if _, err = o.Update(ctx, exec, boil.Whitelist("order_id")); err != nil {
		return errors.Wrap(err, "failed to update local table")
	}

	if o.R != nil {
		o.R.Order = nil
	}
	if related == nil || related.R == nil {
		return nil
	}

	for i, ri := range related.R.OrderRedeemOrderGoals {
		if queries.Equal(o.OrderID, ri.OrderID) {
			continue
		}

		ln := len(related.R.OrderRedeemOrderGoals)
		if ln > 1 && i < ln-1 {
			related.R.OrderRedeemOrderGoals[i] = related.R.OrderRedeemOrderGoals[ln-1]
		}
		related.R.OrderRedeemOrderGoals = related.R.OrderRedeemOrderGoals[:ln-1]
		break
	}
	return nil
}

// RedeemOrderGoals retrieves all the records using an executor.
func RedeemOrderGoals(mods ...qm.QueryMod) redeemOrderGoalQuery {
	mods = append(mods, qm.From("\"redeem_order_goal\""))
	q := NewQuery(mods...)
	if len(queries.GetSelect(q)) == 0 {
		queries.SetSelect(q, []string{"\"redeem_order_goal\".*"})
	}

	return redeemOrderGoalQuery{q}
}

// FindRedeemOrderGoal retrieves a single record by ID with an executor.
// If selectCols is empty Find will return all columns.
func FindRedeemOrderGoal(ctx context.Context, exec boil.ContextExecutor, iD int64, selectCols ...string) (*RedeemOrderGoal, error) {
	redeemOrderGoalObj := &RedeemOrderGoal{}

	sel := "*"
	if len(selectCols) > 0 {
		sel = strings.Join(strmangle.IdentQuoteSlice(dialect.LQ, dialect.RQ, selectCols), ",")
	}
	query := fmt.Sprintf(
		"select %s from \"redeem_order_goal\" where \"id\"=$1", sel,
	)

	q := queries.Raw(query, iD)

	err := q.Bind(ctx, exec, redeemOrderGoalObj)
	if err != nil {
		if errors.Is(err, sql.ErrNoRows) {
			return nil, sql.ErrNoRows
		}
		return nil, errors.Wrap(err, "models: unable to select from redeem_order_goal")
	}

	if err = redeemOrderGoalObj.doAfterSelectHooks(ctx, exec); err != nil {
		return redeemOrderGoalObj, err
	}

	return redeemOrderGoalObj, nil
}

// Insert a single record using an executor.
// See boil.Columns.InsertColumnSet documentation to understand column list inference for inserts.
func (o *RedeemOrderGoal) Insert(ctx context.Context, exec boil.ContextExecutor, columns boil.Columns) error {
	if o == nil {
		return errors.New("models: no redeem_order_goal provided for insertion")
	}

	var err error
	if !boil.TimestampsAreSkipped(ctx) {
		currTime := time.Now().In(boil.GetLocation())

		if o.CreatedAt.IsZero() {
			o.CreatedAt = currTime
		}
		if o.UpdatedAt.IsZero() {
			o.UpdatedAt = currTime
		}
	}

	if err := o.doBeforeInsertHooks(ctx, exec); err != nil {
		return err
	}

	nzDefaults := queries.NonZeroDefaultSet(redeemOrderGoalColumnsWithDefault, o)

	key := makeCacheKey(columns, nzDefaults)
	redeemOrderGoalInsertCacheMut.RLock()
	cache, cached := redeemOrderGoalInsertCache[key]
	redeemOrderGoalInsertCacheMut.RUnlock()

	if !cached {
		wl, returnColumns := columns.InsertColumnSet(
			redeemOrderGoalAllColumns,
			redeemOrderGoalColumnsWithDefault,
			redeemOrderGoalColumnsWithoutDefault,
			nzDefaults,
		)

		cache.valueMapping, err = queries.BindMapping(redeemOrderGoalType, redeemOrderGoalMapping, wl)
		if err != nil {
			return err
		}
		cache.retMapping, err = queries.BindMapping(redeemOrderGoalType, redeemOrderGoalMapping, returnColumns)
		if err != nil {
			return err
		}
		if len(wl) != 0 {
			cache.query = fmt.Sprintf("INSERT INTO \"redeem_order_goal\" (\"%s\") %%sVALUES (%s)%%s", strings.Join(wl, "\",\""), strmangle.Placeholders(dialect.UseIndexPlaceholders, len(wl), 1, 1))
		} else {
			cache.query = "INSERT INTO \"redeem_order_goal\" %sDEFAULT VALUES%s"
		}

		var queryOutput, queryReturning string

		if len(cache.retMapping) != 0 {
			queryReturning = fmt.Sprintf(" RETURNING \"%s\"", strings.Join(returnColumns, "\",\""))
		}

		cache.query = fmt.Sprintf(cache.query, queryOutput, queryReturning)
	}

	value := reflect.Indirect(reflect.ValueOf(o))
	vals := queries.ValuesFromMapping(value, cache.valueMapping)

	if boil.IsDebug(ctx) {
		writer := boil.DebugWriterFrom(ctx)
		fmt.Fprintln(writer, cache.query)
		fmt.Fprintln(writer, vals)
	}

	if len(cache.retMapping) != 0 {
		err = exec.QueryRowContext(ctx, cache.query, vals...).Scan(queries.PtrsFromMapping(value, cache.retMapping)...)
	} else {
		_, err = exec.ExecContext(ctx, cache.query, vals...)
	}

	if err != nil {
		return errors.Wrap(err, "models: unable to insert into redeem_order_goal")
	}

	if !cached {
		redeemOrderGoalInsertCacheMut.Lock()
		redeemOrderGoalInsertCache[key] = cache
		redeemOrderGoalInsertCacheMut.Unlock()
	}

	return o.doAfterInsertHooks(ctx, exec)
}

// Update uses an executor to update the RedeemOrderGoal.
// See boil.Columns.UpdateColumnSet documentation to understand column list inference for updates.
// Update does not automatically update the record in case of default values. Use .Reload() to refresh the records.
func (o *RedeemOrderGoal) Update(ctx context.Context, exec boil.ContextExecutor, columns boil.Columns) (int64, error) {
	if !boil.TimestampsAreSkipped(ctx) {
		currTime := time.Now().In(boil.GetLocation())

		o.UpdatedAt = currTime
	}

	var err error
	if err = o.doBeforeUpdateHooks(ctx, exec); err != nil {
		return 0, err
	}
	key := makeCacheKey(columns, nil)
	redeemOrderGoalUpdateCacheMut.RLock()
	cache, cached := redeemOrderGoalUpdateCache[key]
	redeemOrderGoalUpdateCacheMut.RUnlock()

	if !cached {
		wl := columns.UpdateColumnSet(
			redeemOrderGoalAllColumns,
			redeemOrderGoalPrimaryKeyColumns,
		)

		if !columns.IsWhitelist() {
			wl = strmangle.SetComplement(wl, []string{"created_at"})
		}
		if len(wl) == 0 {
			return 0, errors.New("models: unable to update redeem_order_goal, could not build whitelist")
		}

		cache.query = fmt.Sprintf("UPDATE \"redeem_order_goal\" SET %s WHERE %s",
			strmangle.SetParamNames("\"", "\"", 1, wl),
			strmangle.WhereClause("\"", "\"", len(wl)+1, redeemOrderGoalPrimaryKeyColumns),
		)
		cache.valueMapping, err = queries.BindMapping(redeemOrderGoalType, redeemOrderGoalMapping, append(wl, redeemOrderGoalPrimaryKeyColumns...))
		if err != nil {
			return 0, err
		}
	}

	values := queries.ValuesFromMapping(reflect.Indirect(reflect.ValueOf(o)), cache.valueMapping)

	if boil.IsDebug(ctx) {
		writer := boil.DebugWriterFrom(ctx)
		fmt.Fprintln(writer, cache.query)
		fmt.Fprintln(writer, values)
	}
	var result sql.Result
	result, err = exec.ExecContext(ctx, cache.query, values...)
	if err != nil {
		return 0, errors.Wrap(err, "models: unable to update redeem_order_goal row")
	}

	rowsAff, err := result.RowsAffected()
	if err != nil {
		return 0, errors.Wrap(err, "models: failed to get rows affected by update for redeem_order_goal")
	}

	if !cached {
		redeemOrderGoalUpdateCacheMut.Lock()
		redeemOrderGoalUpdateCache[key] = cache
		redeemOrderGoalUpdateCacheMut.Unlock()
	}

	return rowsAff, o.doAfterUpdateHooks(ctx, exec)
}

// UpdateAll updates all rows with the specified column values.
func (q redeemOrderGoalQuery) UpdateAll(ctx context.Context, exec boil.ContextExecutor, cols M) (int64, error) {
	queries.SetUpdate(q.Query, cols)

	result, err := q.Query.ExecContext(ctx, exec)
	if err != nil {
		return 0, errors.Wrap(err, "models: unable to update all for redeem_order_goal")
	}

	rowsAff, err := result.RowsAffected()
	if err != nil {
		return 0, errors.Wrap(err, "models: unable to retrieve rows affected for redeem_order_goal")
	}

	return rowsAff, nil
}

// UpdateAll updates all rows with the specified column values, using an executor.
func (o RedeemOrderGoalSlice) UpdateAll(ctx context.Context, exec boil.ContextExecutor, cols M) (int64, error) {
	ln := int64(len(o))
	if ln == 0 {
		return 0, nil
	}

	if len(cols) == 0 {
		return 0, errors.New("models: update all requires at least one column argument")
	}

	colNames := make([]string, len(cols))
	args := make([]interface{}, len(cols))

	i := 0
	for name, value := range cols {
		colNames[i] = name
		args[i] = value
		i++
	}

	// Append all of the primary key values for each column
	for _, obj := range o {
		pkeyArgs := queries.ValuesFromMapping(reflect.Indirect(reflect.ValueOf(obj)), redeemOrderGoalPrimaryKeyMapping)
		args = append(args, pkeyArgs...)
	}

	sql := fmt.Sprintf("UPDATE \"redeem_order_goal\" SET %s WHERE %s",
		strmangle.SetParamNames("\"", "\"", 1, colNames),
		strmangle.WhereClauseRepeated(string(dialect.LQ), string(dialect.RQ), len(colNames)+1, redeemOrderGoalPrimaryKeyColumns, len(o)))

	if boil.IsDebug(ctx) {
		writer := boil.DebugWriterFrom(ctx)
		fmt.Fprintln(writer, sql)
		fmt.Fprintln(writer, args...)
	}
	result, err := exec.ExecContext(ctx, sql, args...)
	if err != nil {
		return 0, errors.Wrap(err, "models: unable to update all in redeemOrderGoal slice")
	}

	rowsAff, err := result.RowsAffected()
	if err != nil {
		return 0, errors.Wrap(err, "models: unable to retrieve rows affected all in update all redeemOrderGoal")
	}
	return rowsAff, nil
}

// Upsert attempts an insert using an executor, and does an update or ignore on conflict.
// See boil.Columns documentation for how to properly use updateColumns and insertColumns.
func (o *RedeemOrderGoal) Upsert(ctx context.Context, exec boil.ContextExecutor, updateOnConflict bool, conflictColumns []string, updateColumns, insertColumns boil.Columns) error {
	if o == nil {
		return errors.New("models: no redeem_order_goal provided for upsert")
	}
	if !boil.TimestampsAreSkipped(ctx) {
		currTime := time.Now().In(boil.GetLocation())

		if o.CreatedAt.IsZero() {
			o.CreatedAt = currTime
		}
		o.UpdatedAt = currTime
	}

	if err := o.doBeforeUpsertHooks(ctx, exec); err != nil {
		return err
	}

	nzDefaults := queries.NonZeroDefaultSet(redeemOrderGoalColumnsWithDefault, o)

	// Build cache key in-line uglily - mysql vs psql problems
	buf := strmangle.GetBuffer()
	if updateOnConflict {
		buf.WriteByte('t')
	} else {
		buf.WriteByte('f')
	}
	buf.WriteByte('.')
	for _, c := range conflictColumns {
		buf.WriteString(c)
	}
	buf.WriteByte('.')
	buf.WriteString(strconv.Itoa(updateColumns.Kind))
	for _, c := range updateColumns.Cols {
		buf.WriteString(c)
	}
	buf.WriteByte('.')
	buf.WriteString(strconv.Itoa(insertColumns.Kind))
	for _, c := range insertColumns.Cols {
		buf.WriteString(c)
	}
	buf.WriteByte('.')
	for _, c := range nzDefaults {
		buf.WriteString(c)
	}
	key := buf.String()
	strmangle.PutBuffer(buf)

	redeemOrderGoalUpsertCacheMut.RLock()
	cache, cached := redeemOrderGoalUpsertCache[key]
	redeemOrderGoalUpsertCacheMut.RUnlock()

	var err error

	if !cached {
		insert, ret := insertColumns.InsertColumnSet(
			redeemOrderGoalAllColumns,
			redeemOrderGoalColumnsWithDefault,
			redeemOrderGoalColumnsWithoutDefault,
			nzDefaults,
		)

		update := updateColumns.UpdateColumnSet(
			redeemOrderGoalAllColumns,
			redeemOrderGoalPrimaryKeyColumns,
		)

		if updateOnConflict && len(update) == 0 {
			return errors.New("models: unable to upsert redeem_order_goal, could not build update column list")
		}

		conflict := conflictColumns
		if len(conflict) == 0 {
			conflict = make([]string, len(redeemOrderGoalPrimaryKeyColumns))
			copy(conflict, redeemOrderGoalPrimaryKeyColumns)
		}
		cache.query = buildUpsertQueryPostgres(dialect, "\"redeem_order_goal\"", updateOnConflict, ret, update, conflict, insert)

		cache.valueMapping, err = queries.BindMapping(redeemOrderGoalType, redeemOrderGoalMapping, insert)
		if err != nil {
			return err
		}
		if len(ret) != 0 {
			cache.retMapping, err = queries.BindMapping(redeemOrderGoalType, redeemOrderGoalMapping, ret)
			if err != nil {
				return err
			}
		}
	}

	value := reflect.Indirect(reflect.ValueOf(o))
	vals := queries.ValuesFromMapping(value, cache.valueMapping)
	var returns []interface{}
	if len(cache.retMapping) != 0 {
		returns = queries.PtrsFromMapping(value, cache.retMapping)
	}

	if boil.IsDebug(ctx) {
		writer := boil.DebugWriterFrom(ctx)
		fmt.Fprintln(writer, cache.query)
		fmt.Fprintln(writer, vals)
	}
	if len(cache.retMapping) != 0 {
		err = exec.QueryRowContext(ctx, cache.query, vals...).Scan(returns...)
		if errors.Is(err, sql.ErrNoRows) {
			err = nil // Postgres doesn't return anything when there's no update
		}
	} else {
		_, err = exec.ExecContext(ctx, cache.query, vals...)
	}
	if err != nil {
		return errors.Wrap(err, "models: unable to upsert redeem_order_goal")
	}

	if !cached {
		redeemOrderGoalUpsertCacheMut.Lock()
		redeemOrderGoalUpsertCache[key] = cache
		redeemOrderGoalUpsertCacheMut.Unlock()
	}

	return o.doAfterUpsertHooks(ctx, exec)
}

// Delete deletes a single RedeemOrderGoal record with an executor.
// Delete will match against the primary key column to find the record to delete.
func (o *RedeemOrderGoal) Delete(ctx context.Context, exec boil.ContextExecutor) (int64, error) {
	if o == nil {
		return 0, errors.New("models: no RedeemOrderGoal provided for delete")
	}

	if err := o.doBeforeDeleteHooks(ctx, exec); err != nil {
		return 0, err
	}

	args := queries.ValuesFromMapping(reflect.Indirect(reflect.ValueOf(o)), redeemOrderGoalPrimaryKeyMapping)
	sql := "DELETE FROM \"redeem_order_goal\" WHERE \"id\"=$1"

	if boil.IsDebug(ctx) {
		writer := boil.DebugWriterFrom(ctx)
		fmt.Fprintln(writer, sql)
		fmt.Fprintln(writer, args...)
	}
	result, err := exec.ExecContext(ctx, sql, args...)
	if err != nil {
		return 0, errors.Wrap(err, "models: unable to delete from redeem_order_goal")
	}

	rowsAff, err := result.RowsAffected()
	if err != nil {
		return 0, errors.Wrap(err, "models: failed to get rows affected by delete for redeem_order_goal")
	}

	if err := o.doAfterDeleteHooks(ctx, exec); err != nil {
		return 0, err
	}

	return rowsAff, nil
}

// DeleteAll deletes all matching rows.
func (q redeemOrderGoalQuery) DeleteAll(ctx context.Context, exec boil.ContextExecutor) (int64, error) {
	if q.Query == nil {
		return 0, errors.New("models: no redeemOrderGoalQuery provided for delete all")
	}

	queries.SetDelete(q.Query)

	result, err := q.Query.ExecContext(ctx, exec)
	if err != nil {
		return 0, errors.Wrap(err, "models: unable to delete all from redeem_order_goal")
	}

	rowsAff, err := result.RowsAffected()
	if err != nil {
		return 0, errors.Wrap(err, "models: failed to get rows affected by deleteall for redeem_order_goal")
	}

	return rowsAff, nil
}

// DeleteAll deletes all rows in the slice, using an executor.
func (o RedeemOrderGoalSlice) DeleteAll(ctx context.Context, exec boil.ContextExecutor) (int64, error) {
	if len(o) == 0 {
		return 0, nil
	}

	if len(redeemOrderGoalBeforeDeleteHooks) != 0 {
		for _, obj := range o {
			if err := obj.doBeforeDeleteHooks(ctx, exec); err != nil {
				return 0, err
			}
		}
	}

	var args []interface{}
	for _, obj := range o {
		pkeyArgs := queries.ValuesFromMapping(reflect.Indirect(reflect.ValueOf(obj)), redeemOrderGoalPrimaryKeyMapping)
		args = append(args, pkeyArgs...)
	}

	sql := "DELETE FROM \"redeem_order_goal\" WHERE " +
		strmangle.WhereClauseRepeated(string(dialect.LQ), string(dialect.RQ), 1, redeemOrderGoalPrimaryKeyColumns, len(o))

	if boil.IsDebug(ctx) {
		writer := boil.DebugWriterFrom(ctx)
		fmt.Fprintln(writer, sql)
		fmt.Fprintln(writer, args)
	}
	result, err := exec.ExecContext(ctx, sql, args...)
	if err != nil {
		return 0, errors.Wrap(err, "models: unable to delete all from redeemOrderGoal slice")
	}

	rowsAff, err := result.RowsAffected()
	if err != nil {
		return 0, errors.Wrap(err, "models: failed to get rows affected by deleteall for redeem_order_goal")
	}

	if len(redeemOrderGoalAfterDeleteHooks) != 0 {
		for _, obj := range o {
			if err := obj.doAfterDeleteHooks(ctx, exec); err != nil {
				return 0, err
			}
		}
	}

	return rowsAff, nil
}

// Reload refetches the object from the database
// using the primary keys with an executor.
func (o *RedeemOrderGoal) Reload(ctx context.Context, exec boil.ContextExecutor) error {
	ret, err := FindRedeemOrderGoal(ctx, exec, o.ID)
	if err != nil {
		return err
	}

	*o = *ret
	return nil
}

// ReloadAll refetches every row with matching primary key column values
// and overwrites the original object slice with the newly updated slice.
func (o *RedeemOrderGoalSlice) ReloadAll(ctx context.Context, exec boil.ContextExecutor) error {
	if o == nil || len(*o) == 0 {
		return nil
	}

	slice := RedeemOrderGoalSlice{}
	var args []interface{}
	for _, obj := range *o {
		pkeyArgs := queries.ValuesFromMapping(reflect.Indirect(reflect.ValueOf(obj)), redeemOrderGoalPrimaryKeyMapping)
		args = append(args, pkeyArgs...)
	}

	sql := "SELECT \"redeem_order_goal\".* FROM \"redeem_order_goal\" WHERE " +
		strmangle.WhereClauseRepeated(string(dialect.LQ), string(dialect.RQ), 1, redeemOrderGoalPrimaryKeyColumns, len(*o))

	q := queries.Raw(sql, args...)

	err := q.Bind(ctx, exec, &slice)
	if err != nil {
		return errors.Wrap(err, "models: unable to reload all in RedeemOrderGoalSlice")
	}

	*o = slice

	return nil
}

// RedeemOrderGoalExists checks if the RedeemOrderGoal row exists.
func RedeemOrderGoalExists(ctx context.Context, exec boil.ContextExecutor, iD int64) (bool, error) {
	var exists bool
	sql := "select exists(select 1 from \"redeem_order_goal\" where \"id\"=$1 limit 1)"

	if boil.IsDebug(ctx) {
		writer := boil.DebugWriterFrom(ctx)
		fmt.Fprintln(writer, sql)
		fmt.Fprintln(writer, iD)
	}
	row := exec.QueryRowContext(ctx, sql, iD)

	err := row.Scan(&exists)
	if err != nil {
		return false, errors.Wrap(err, "models: unable to check if redeem_order_goal exists")
	}

	return exists, nil
}

// Exists checks if the RedeemOrderGoal row exists.
func (o *RedeemOrderGoal) Exists(ctx context.Context, exec boil.ContextExecutor) (bool, error) {
	return RedeemOrderGoalExists(ctx, exec, o.ID)
}
